'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Note: This sample PDF viewer is made available for download
' from www.quickpdflibrary.com with permission from its authors.
' This is a sample only. Do not use it in a production environment.
'
' In order to run this sample you must obtain a trial license key.
' If you do not already have one, you can obtain one by emailing
' sales@quickpdflibrary.com.
' -----------------------------------------------------------------
'
' PDF View, a PowerBASIC PDF Viewer
'       Based on the Quick PDF Library 7.21, DLL version
'       Available at: www.quickpdflibrary.com
'
' Released to the public domain on March 15, 2009
'       This software is free and may be used in private and commercial projects
'       Credit is always appreciated but not requested or required
'       If you profit from this software, Karma dictates you be nice and share
'               My suggestion, Kiva at: http://www.kiva.org/app.php
'       If this software makes you filthy rich <smile> you'll be required to share
'       your financial good fortune from this software with me also <smile>
'
' Acknowledgments:
'   Joe Byrne, thanks for planting the seed that got this project going
'       Rowan Hanna, thanks for helping with Quick PDF questions, we're not done yet!
'       Hans Rietveld, thanks for correcting and updating "QuickPDFDLL0712.inc"
'
' Background:
'       http://www.powerbasic.com/support/pbforums/showthread.php?t=39904
'       http://www.powerbasic.com/support/pbforums/showthread.php?t=40025
'       http://www.powerbasic.com/support/pbforums/showthread.php?t=40085
'
'   The project:
'       Compiler:       PowerBASIC 9.01
'   Tested on:  Windows XP SP3
'       DLL used:       QuickPDFDLL0713.dll (final release)
'       Include:        QuickPDFDLL0713.inc (final release)
'       Display:        1024x768 (application opens a 1000x768 window, this will change)
'
'   History:
'       Mar 15, 2009 - Version 0.01 by Marc Giao
'           Original code release
'           Added option to load and view single PDF files
'           Added zoom in and out feature
'           Added next and previous page feature
'
'       Mar 22, 2009 - Version 0.05 by Marc Giao
'           Added some error checking
'           Added printing (with input from Hans Rietveld)
'           Added window resizing
'
'       Apr 11, 2009 - Version 0.10 by Marc Giao
'           Added scroll bars
'           Added full screen button
'           Added status bar
'           Added minimum resizing limits
'           Zoom now goes to 3x
'           Page now centres on the screen
'
'       Apr 26, 2009 - Version 0.30 by Marc Giao
'           Changed project name to "Open View"
'           Added multiple open files option
'           Added option to open additional file formats (jpg, bmp, png, etc)
'           Added go to page option
'           %APPDATA% directory is now used for all data files
'           Improved scrollbars
'           Fixed printing issue repoted by Hans Rietveld
'           Fixed issue with landscape files
'           fixed misc. other minor issues
'
'       May 3, 2009 - Version 0.40 by Marc Giao
'           Compiled wirh new trial license
'           Open file dialog now remembers previous path
'           Tweaks to page display and position
'           Tweaks to display colour
'           Tweaks to text positions
'
'   WARNING: This is not production ready code, it's a work in progress and
'   only minimal error checking is currently provided.
'
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

#DIM ALL
#COMPILE EXE "OpenView.exe"
#INCLUDE "WIN32API.inc"
#INCLUDE "QuickPDFDLL0721.inc"
#RESOURCE "OpenView.pbr"

$VerNum             = "0.40"
$UnlockKey  =   "Insert License Key Here"
$OnlyValid  = "Valid Only (*.bmp/emf/gif/jpg/jpeg/pdf/png/tif/wmf)" + $NUL _
                        + "*.pdf;*.bmp;*.emf;*.gif;*.png;*.wmf;*.jpg;*.jpeg;*.tif" + $NUL
$ALLFilter  = "ALL Files (*.*)" + $NUL + "*.*" + $NUL
$PDFFilter  = "PDF Files (*.pdf)" + $NUL + "*.pdf" + $NUL
$BMPFilter  = "BMP Files (*.bmp)" + $NUL + "*.bmp" + $NUL
$EMFFilter  = "EMF Files (*.emf)" + $NUL + "*.emf" + $NUL
$GIFFilter  = "GIF Files (*.gif)" + $NUL + "*.gif" + $NUL
$PNGFilter  = "PNG Files (*.png)" + $NUL + "*.png" + $NUL
$WMFFilter  = "WMF Files (*.wmf)" + $NUL + "*.wmf" + $NUL
$JPEGFilter     = "JPEG Files (*.jpg)" + $NUL + "*.jpg" + $NUL
$TIFFFilter     = "TIFF Files (*.tif)" + $NUL + "*.tif" + $NUL

' control id's
    %VDisplay       = 1000 ' graphic, visible display area of the hidden buffer
    %HorSB          = 1001 ' scrollbar, horizontal display scroll
    %VerSB          = 1002 ' scrollbar, vertical display scroll
    %FullScreen     = 1003 ' button, full screen
    %FileGroup  =   1004 ' frame, file group
    %LoadFile       = 1005 ' button, load file from disk
    %CloseFile  = 1029 ' button, close current file
    %LblCurrent     =   1006 ' label, current document
    %CurrentDoc     =   1007 ' combobox, current file display/selection
    %ZoomGroup  = 1008 ' frame, zoom group
    %Zoom_I             = 1009 ' button, zoom in
    %ZoomVal        = 1010 ' current zoom value display
    %Zoom_O             = 1011 ' button, zoom out
    %PageGroup  = 1012 ' frame, page group
    %N_Page             = 1013 ' button, next page
    %PageNum        = 1014 ' current page number display
    %P_Page             = 1015 ' button, previous page
    %PrintGroup     = 1016 ' frame, print group
    %PrintAll       = 1017 ' option, print all pages
    %PrintOdd       = 1018 ' option, print odd pages only
    %PrintEven  = 1019 ' option, print even pages only
    %LblRange       =   1020 ' label, page print range
    %PageRange  =   1021 ' textbox, page print range
    %LblPrinter     = 1022 ' label, current printer
    %Printer        = 1023 ' textbox, current printer
    %PrintPDF       = 1024 ' button, print current document
    %PrintSetup     = 1025 ' button, printer setup
    %ShowInfo       = 1026 ' statusbar, show information

' limits and sizes
    %MinWinW        = 800 ' minimum dialog width, arbitrary value
    %MinWinH        = 600 ' minimum dialog height, arbitrary value
    %ZoomDef        = 72 ' default zoom factor, arbitrary value
    %ZoomMax        = 216 ' max zoom factor (72 * 3) limited by avail mem
    %ZoomMin        = 36 ' min zoom factor (72 / 2) arbitrary value
    %BMaxW          = 1836 ' 8.5*72*3=1836  | 3x max zoom buffer
    %BMaxH          = 2376 ' 11*72*3=2376       | total: 1836*2376=4,362,336 bites

GLOBAL LibInstance  AS LONG ' library instance
GLOBAL MainHndl             AS LONG ' handle to main dialog handle
GLOBAL BufferA          AS LONG ' handle to hidden image buffer

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
FUNCTION PBMAIN( ) AS LONG
LOCAL DColour   AS LONG
DColour&    = RGB( 196, 203, 209 )

' the main dialog
    DIALOG NEW PIXELS, 0, "Open View", 10, 10, 1000, 768 _
        , %WS_POPUPWINDOW OR %WS_CAPTION OR %WS_MINIMIZEBOX OR %WS_THICKFRAME _ ' OR %WS_MAXIMIZEBOX
        ,  _
        TO MainHndl&

' the status bar on the main dialog
    CONTROL ADD STATUSBAR, MainHndl&, %ShowInfo, "Status Bar", 0, 0, 0, 0, %CCS_BOTTOM 'OR %SBARS_SIZEGRIP,, ' CALL OnEvent_??()
CONTROL SET COLOR MainHndl&, %ShowInfo, -1, DColour&

' the display scrollbars on the main dialog
    CONTROL ADD SCROLLBAR, MainHndl&, %HorSB,"", 0, 0, 30, 20, %SBS_HORZ, %WS_EX_LEFT, CALL OnEvent_Scroll( )
    CONTROL ADD SCROLLBAR, MainHndl&, %VerSB,"", 0, 0, 20, 30, %SBS_VERT, %WS_EX_LEFT, CALL OnEvent_Scroll( )
    CONTROL ADD BUTTON, MainHndl&, %FullScreen, ">>", 0, 0, 19, 19,,, CALL OnEvent_FullScreen( )
CONTROL SET COLOR MainHndl&, %FullScreen, -1, DColour&

' file group on the main dialog
    CONTROL ADD FRAME, MainHndl&, %FileGroup, "FILE", 87, 5, 128, 120,,
CONTROL SET COLOR MainHndl&, %FileGroup, -1, DColour&

    CONTROL ADD BUTTON, MainHndl&, %LoadFile, "Open File", 874, 20, 120, 30,,, CALL OnEvent_FileLoad( )
CONTROL SET COLOR MainHndl&, %LoadFile, -1, DColour&
    CONTROL ADD LABEL, MainHndl&, %LblCurrent, "Current File:",876, 53, 120, 15,,,
CONTROL SET COLOR MainHndl&, %LblCurrent, -1, DColour&
    CONTROL ADD COMBOBOX, MainHndl&, %CurrentDoc, , 874, 70, 120, 25, %CBS_DROPDOWN,, CALL OnEvent_FileSwitch( )
'CONTROL SET COLOR MainHndl&, %CurrentDoc, -1, DColour&
    CONTROL ADD BUTTON, MainHndl&, %CloseFile, "Close File", 874, 95, 120, 30,,, CALL OnEvent_FileClose( )
CONTROL SET COLOR MainHndl&, %CloseFile, -1, DColour&

' zoom group on the main dialog
    CONTROL ADD FRAME, MainHndl&, %ZoomGroup, "ZOOM", 870, 100, 128, 50,,
CONTROL SET COLOR MainHndl&, %ZoomGroup, -1, DColour&
    CONTROL ADD BUTTON, MainHndl&, %Zoom_O, "Out", 874, 115, 40, 30,,, CALL OnEvent_Zoom( )
CONTROL SET COLOR MainHndl&, %Zoom_O, -1, DColour&
    CONTROL ADD TEXTBOX, MainHndl&, %ZoomVal, "0000", 915, 123, 35, 17, %ES_READONLY OR %ES_CENTER OR %WS_BORDER,, ' CALL OnEvent_??()
    CONTROL ADD BUTTON, MainHndl&, %Zoom_I, "In", 954, 115, 40, 30,,, CALL OnEvent_Zoom( )
CONTROL SET COLOR MainHndl&, %Zoom_I, -1, DColour&

' page group on the main dialog
    CONTROL ADD FRAME, MainHndl&, %PageGroup, "PAGE", 870, 155, 128, 50,,
CONTROL SET COLOR MainHndl&, %PageGroup, -1, DColour&
    CONTROL ADD BUTTON, MainHndl&, %P_Page, "<<", 874, 170, 40, 30,,, CALL OnEvent_Page( )
CONTROL SET COLOR MainHndl&, %P_Page, -1, DColour&
    CONTROL ADD TEXTBOX, MainHndl&, %PageNum, "0000", 915, 178, 35, 17, %WS_TABSTOP OR %ES_CENTER OR %WS_BORDER, CALL OnEvent_Page( )
    CONTROL ADD BUTTON, MainHndl&, %N_Page, ">>", 954, 170, 40, 30,,, CALL OnEvent_Page( )
CONTROL SET COLOR MainHndl&, %N_Page, -1, DColour&

' print group on the main dialog
    CONTROL ADD FRAME, MainHndl&, %PrintGroup, "PRINT", 870, 210, 128, 135,,
CONTROL SET COLOR MainHndl&, %PrintGroup, -1, DColour&
    CONTROL ADD OPTION, MainHndl&, %PrintAll, "All", 876, 225, 34, 15,, CALL OnEvent_Print( )
CONTROL SET COLOR MainHndl&, %PrintAll, -1, DColour&
    CONTROL ADD OPTION, MainHndl&, %PrintOdd, "Odd", 909, 225, 42, 15,, CALL OnEvent_Print( )
CONTROL SET COLOR MainHndl&, %PrintOdd, -1, DColour&
    CONTROL ADD OPTION, MainHndl&, %PrintEven, "Even", 950, 225, 45, 15,, CALL OnEvent_Print( )
CONTROL SET COLOR MainHndl&, %PrintEven, -1, DColour&
    CONTROL ADD LABEL, MainHndl&, %LblRange, "Page Range:", 875, 242, 120, 15,, ' CALL OnEvent_??()
CONTROL SET COLOR MainHndl&, %LblRange, -1, DColour&
    CONTROL ADD TEXTBOX, MainHndl&, %PageRange, "", 875, 255, 118, 17, %WS_TABSTOP OR %ES_CENTER OR %WS_BORDER,, ' CALL OnEvent_???()
    CONTROL ADD LABEL, MainHndl&, %LblPrinter, "Print Using:", 875, 275, 117, 15,, ' CALL OnEvent_??()
CONTROL SET COLOR MainHndl&, %LblPrinter, -1, DColour&
    CONTROL ADD TEXTBOX, MainHndl&, %Printer, "", 875, 280, 118, 18, %WS_BORDER OR %ES_READONLY,, ' CALL OnEvent_???()
    CONTROL ADD BUTTON, MainHndl&, %PrintPDF, "Print", 874, 290, 80, 30,,, CALL OnEvent_Print( )
CONTROL SET COLOR MainHndl&, %PrintPDF, -1, DColour&
    CONTROL ADD BUTTON, MainHndl&, %PrintSetup, "Set Up", 954, 275, 40, 30,,, CALL OnEvent_Print( )
CONTROL SET COLOR MainHndl&, %PrintSetup, -1, DColour&

    DIALOG SHOW MODAL MainHndl&, CALL OnEvent_MainDlg

END FUNCTION ' PBMAIN

CALLBACK FUNCTION OnEvent_MainDlg( ) AS LONG
LOCAL Result    AS LONG
LOCAL LastMsg   AS LONG
LOCAL CBCount   AS LONG
LOCAL CBIndex   AS LONG
LOCAL DocId         AS LONG

LOCAL TmpPath AS STRING

IF CB.HNDL = MainHndl& THEN

    SELECT CASE AS LONG CB.MSG
        CASE %WM_MOVE : FUNCTION = 1
    ' dialog is moving
            DIALOG GET USER CB.HNDL, 8 TO LastMsg& ' get last message
            IF LastMsg& = %WM_INITDIALOG THEN
                DIALOG SET USER CB.HNDL, 8, 0 ' clear last message
            ELSE
                DIALOG SET USER CB.HNDL, 8, CB.MSG ' save current message
            END IF

        CASE %WM_SIZING : FUNCTION = 1
    ' dialog is resizing
            Result& = UpdateControls( CB.HNDL, 0 )
            DIALOG SET USER CB.HNDL, 8, CB.MSG ' save current message

        CASE %WM_EXITSIZEMOVE : FUNCTION = 1
    ' dialog is done resizing or moving
            DIALOG GET USER CB.HNDL, 8 TO LastMsg& ' get last message
            IF LastMsg& = %WM_MOVE THEN
                DIALOG SET USER CB.HNDL, 8, 0 ' clear last message
            ELSE
                Result& = UpdateControls( CB.HNDL, 1 )
            END IF

        CASE %WM_INITDIALOG : FUNCTION = 1
    ' main dialog is about to be shown
            DIALOG SET USER CB.HNDL, 8, CB.MSG ' save current message
    ' set the app caption
            DIALOG SET TEXT CB.HNDL, "Open View   Ver. " + $VerNum
    ' set the dialog colour
            DIALOG SET COLOR CB.HNDL, -1, RGB( 196, 203,209 )
    ' setup the satatusbar
            STATUSBAR SET PARTS CB.HNDL, %ShowInfo, 100, 100, 150, 150, 999
    ' create hidden rendering buffer
            GRAPHIC BITMAP NEW %BMaxW, %BMaxH TO BufferA
    ' set the initial zoom level
            CONTROL SET USER CB.HNDL, %ZoomVal, 1, %ZoomDef
    ' retrieve default printer name
            XPRINT ATTACH DEFAULT ' capture default printer
            CONTROL SET TEXT CB.HNDL, %Printer, XPRINT$
            XPRINT CLOSE ' release printer

    ' get the library instance, abort is unable
            LibInstance& = QuickPDFCreateLibrary( )
            IF LibInstance& THEN
                STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 1, 0, "Instance... OK"

            ELSE
                MSGBOX "Unable to aquire library instance. Terminating application" ,%MB_ICONERROR, "Fatal Error"
                DIALOG END CB.HNDL

            END IF

    ' unlock library, abort if unable
            IF QuickPDFUnlockKey( LibInstance&, $UnlockKey + $NUL ) THEN
                STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 2, 0, "Unlock... OK"

            ELSE
                MSGBOX "Unable to unlock library. Terminating application" ,%MB_ICONERROR, "Fatal Error"
                DIALOG END CB.HNDL

            END IF

    ' setup temp file and path, show error if unable
            TmpPath$ = ENVIRON$( "APPDATA" ) + "\OpenView"
            IF DIR$( TmpPath$, ONLY 16 ) = "" THEN MKDIR TmpPath$
            IF QuickPDFSetTempPath( LibInstance&, TmpPath$ + $NUL ) _
            AND QuickPDFSetTempFile( LibInstance&, TmpPath$ + "\QPDFTemp.dat" + $NUL ) _
            THEN
                STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 3, 0, "Temp Path/Name... OK"

            ELSE
                STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 3, 0, "Temp Path/Name... FAIL"

            END IF
    ' display app and library info
            STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 4, 0, "Quick PDF Library Ver. " + QuickPDFLibraryVersion( LibInstance& )
            STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 5, 0, "Ready..."
    ' update screen
            CALL UpdateControls( CB.HNDL, 1 )
    ' display built with logo
            CALL BuiltWith( CB.HNDL )

        CASE %WM_DESTROY : FUNCTION = 1
    ' main dialog is about to be destroyed
            COMBOBOX GET COUNT CB.HNDL, %CurrentDoc TO CBCount&
            IF CBCount& THEN
                FOR CBIndex& = 1 TO CBCount&
                    COMBOBOX GET USER CB.HNDL, %CurrentDoc, CBIndex& TO DocId&
                    Result& = QuickPDFRemoveDocument( LibInstance&, DocId& )
                NEXT CBIndex&

            END IF

            Result& = QuickPDFReleaseLibrary( LibInstance& )

            GRAPHIC ATTACH BufferA, 0
            GRAPHIC BITMAP END

    END SELECT
END IF

END FUNCTION ' OnEvent_MainDlg

CALLBACK FUNCTION OnEvent_FileLoad( ) AS LONG
STATIC FPath        AS STRING
LOCAL FName             AS STRING
LOCAL FExtn             AS STRING
LOCAL Filter        AS STRING
LOCAL Selection AS STRING
LOCAL ImageW        AS LONG
LOCAL ImageH        AS LONG
LOCAL Result        AS LONG

IF  CB.MSG = %WM_COMMAND AND CB.CTLMSG = %BN_CLICKED THEN

    SELECT CASE CB.CTL
        CASE %LoadFile
            Filter$ = $OnlyValid+$PDFFilter+$BMPFilter+$EMFFilter+$GIFFilter _
                            + $PNGFilter+$WMFFilter+$JPEGFilter+$TIFFFilter+$ALLFilter
            DISPLAY OPENFILE CB.HNDL, , , "Open File", "FPath$", Filter$, "", "" _
                , %OFN_ENABLESIZING OR %OFN_FILEMUSTEXIST OR %OFN_PATHMUSTEXIST TO Selection$ ' [,countvar&]

            IF Selection$ = "" THEN EXIT SELECT

            FPath$ = PATHNAME$( PATH, Selection$ )
            FName$ = PATHNAME$( NAME, Selection$ )
            FExtn$ = LCASE$( PATHNAME$( EXTN, Selection$ ) )

        ' handle pdf files
            IF FExtn$ = ".pdf" THEN
                COMBOBOX FIND EXACT CB.HNDL, %CurrentDoc, 1, FName$ TO Result&
                IF Result& = 0 THEN
                    Result& = QuickPDFLoadFromFile( LibInstance&, Selection$ + $NUL )
                    COMBOBOX ADD CB.HNDL, %CurrentDoc, FName$
                    COMBOBOX FIND EXACT CB.HNDL, %CurrentDoc, 1, FName$ TO Result&
                    COMBOBOX SELECT CB.HNDL, %CurrentDoc, Result&
                    COMBOBOX SET USER CB.HNDL, %CurrentDoc, Result&, QuickPDFSelectedDocument( LibInstance& )

                ELSE
                    MSGBOX "File already loaded" ,%MB_ICONWARNING, "File Error"
                    EXIT FUNCTION

                END IF

        ' handle BMP, TIFF, JPEG, PNG, GIF, WMF and EMF files
            ELSE
                COMBOBOX FIND EXACT CB.HNDL, %CurrentDoc, 1, FName$ TO Result&
                IF Result& = 0 THEN
                    COMBOBOX ADD CB.HNDL, %CurrentDoc, FName$
                    COMBOBOX FIND EXACT CB.HNDL, %CurrentDoc, 1, FName$ TO Result&
                    COMBOBOX SELECT CB.HNDL, %CurrentDoc, Result&
                    COMBOBOX SET USER CB.HNDL, %CurrentDoc, Result&, QuickPDFNewDocument( LibInstance& )
                '   Result& = QuickPDFCompressImages( LibInstance&, 1 )
                    Result& = QuickPDFAddImageFromFile( LibInstance&, Selection$ + $NUL, 0 )
                    Result& = QuickPDFSelectImage( LibInstance&, Result& )
                    ImageW& = QuickPDFImageWidth( LibInstance& )
                    ImageH& = QuickPDFImageHeight( LibInstance& )
                    Result& = QuickPDFSetPageDimensions( LibInstance&, ImageW&, ImageH& )
                    ImageW& = MIN( %BMaxW, ImageW& ) : ImageH& = MIN( %BMaxH, ImageH& )
                    Result&     = QuickPDFSetOrigin( LibInstance&, 1 ) ' top left corner
                    Result& = QuickPDFDrawImage( LibInstance&, 0, 0, ImageW&, ImageH& )

                END IF

            END IF

            IF QuickPDFPageCount( LibInstance& ) AND QuickPDFSelectedPage( LibInstance& ) THEN
            ' document appears valid, render it
                CALL UpdateBuffer( CB.HNDL )
                CALL UpdateScroll( CB.HNDL )
                CALL UpdateScreen( CB.HNDL )
                CALL UpdateDocInfo( )

            ELSE
                MSGBOX "Unable to process loaded file" ,%MB_ICONWARNING, "File Error"
            END IF

            FUNCTION = 1

        FPath$ = PATHNAME$( PATH, FPath$ )
        CASE %CloseFile

    END SELECT

END IF

END FUNCTION ' OnEvent_LoadFile

CALLBACK FUNCTION OnEvent_FileClose( ) AS LONG
LOCAL Result    AS LONG
LOCAL CBIndex   AS LONG
LOCAL CBCount   AS LONG
LOCAL DocId         AS LONG

IF CB.MSG = %WM_COMMAND AND CB.CTLMSG = %BN_CLICKED THEN

    IF CB.CTL = %CloseFile THEN
        COMBOBOX GET SELECT CB.HNDL, %CurrentDoc TO CBIndex&
        COMBOBOX GET USER CB.HNDL, %CurrentDoc, CBIndex& TO DocId&
        COMBOBOX DELETE CB.HNDL, %CurrentDoc, CBIndex&
        Result& = QuickPDFRemoveDocument( LibInstance&, DocId& )
        COMBOBOX GET COUNT CB.HNDL, %CurrentDoc TO CBCount&

        IF CBCount& THEN
            COMBOBOX SELECT CB.HNDL, %CurrentDoc, CBCount&
            COMBOBOX GET USER CB.HNDL, %CurrentDoc, CBCount& TO DocId&
            Result& = QuickPDFSelectDocument( LibInstance&, DocId& )

        ELSE
            COMBOBOX RESET CB.HNDL, %CurrentDoc

        END IF

        CALL UpdateBuffer( CB.HNDL )
        CALL UpdateScroll( CB.HNDL )
        CALL UpdateScreen( CB.HNDL )
        CALL UpdateDocInfo( )

    END IF

END IF

END FUNCTION ' OnEvent_CloseFile

CALLBACK FUNCTION OnEvent_FileSwitch( ) AS LONG
LOCAL Result    AS LONG
LOCAL CBIndex   AS LONG
LOCAL DocId         AS LONG

IF CB.MSG = %WM_COMMAND AND CB.CTL = %CurrentDoc THEN
    SELECT CASE CB.CTLMSG
        CASE %CBN_SETFOCUS
        CASE %CBN_SELCHANGE
            COMBOBOX GET SELECT CB.HNDL, %CurrentDoc TO CBIndex&
            COMBOBOX GET USER CB.HNDL, %CurrentDoc, CBIndex& TO DocId&

            IF QuickPDFSelectDocument( LibInstance&, DocId& ) THEN

                CALL UpdateBuffer( CB.HNDL )
                CALL UpdateScroll( CB.HNDL )
                CALL UpdateScreen( CB.HNDL )
                CALL UpdateDocInfo( )

            END IF

        CASE %CBN_KILLFOCUS

    END SELECT

END IF

END FUNCTION ' OnEvent_ShowDoc

CALLBACK FUNCTION OnEvent_Zoom( ) AS LONG
LOCAL ZF    AS LONG
LOCAL PN    AS LONG
LOCAL   BIW     AS LONG
LOCAL   BIH     AS LONG

IF  CB.MSG = %WM_COMMAND AND CB.CTLMSG = %BN_CLICKED THEN
    CONTROL GET USER CB.HNDL, %ZoomVal, 1 TO ZF&

    SELECT CASE CB.CTL
        CASE %Zoom_I : FUNCTION = 1
            ZF& += 6 : ZF& = MIN( %ZoomMax, ZF& )
        ' account for page rotation
            SELECT CASE QuickPDFPageRotation( LibInstance& )
                CASE 0 ' Portrait
                    BIW& = ZF& * ROUND( QuickPDFPageWidth( LibInstance& ), 2 )
                    BIH& = ZF& * ROUND( QuickPDFPageHeight( LibInstance& ), 2 )

                CASE 90 ' Landscape
                    BIW& = ZF& * ROUND( QuickPDFPageHeight( LibInstance& ), 2 )
                    BIH& = ZF& * ROUND( QuickPDFPageWidth( LibInstance& ), 2 )

                CASE 180 ' Flipped Portrait

                CASE 270 ' Flipped Landscape

            END SELECT

        ' make sure we're still within the buffer
            IF ( BIW& > %BMaxW ) OR ( BIH& > %BMaxH ) THEN ZF& -= 6

        CASE %Zoom_O : FUNCTION = 1
            ZF& -= 6 : ZF& = MAX( %ZoomMin, ZF& )

    END SELECT

    CONTROL SET USER CB.HNDL, %ZoomVal, 1, ZF&
    CALL UpdateBuffer( CB.HNDL )
    CALL UpdateScroll( CB.HNDL )
    CALL UpdateScreen( CB.HNDL )

END IF

END FUNCTION ' OnEvent_Zoom

CALLBACK FUNCTION OnEvent_Page( ) AS LONG
LOCAL FR    AS LONG
LOCAL PC    AS LONG
LOCAL PN    AS LONG
LOCAL ZF    AS LONG
LOCAL Txt AS STRING

IF CB.MSG = %WM_COMMAND THEN
    PC& = QuickPDFPageCount( LibInstance& )
    PN& = QuickPDFSelectedPage( LibInstance& )
    DIALOG GET USER CB.HNDL, 1 TO ZF&

    SELECT CASE CB.CTL
        CASE %N_Page : FUNCTION = 1
            IF CB.CTLMSG = %BN_CLICKED THEN
                INCR PN& : PN& = MIN( PN&, PC& )
                CONTROL SET USER CB.HNDL, %PageNum, 1, %EN_KILLFOCUS

            END IF

        CASE %P_Page : FUNCTION = 1
            IF CB.CTLMSG = %BN_CLICKED THEN
                DECR PN& : PN& = MAX( PN&, 1 )
                CONTROL SET USER CB.HNDL, %PageNum, 1, %EN_KILLFOCUS

            END IF

        CASE %PageNum
            SELECT CASE CB.CTLMSG
                CASE %EN_SETFOCUS : FUNCTION = 1
                    CONTROL SET USER CB.HNDL, %PageNum, 1, %EN_SETFOCUS

                CASE %EN_CHANGE : FUNCTION = 1
                    CONTROL GET USER CB.HNDL, %PageNum, 1 TO FR&
                    IF FR& = %EN_SETFOCUS THEN
                        CONTROL SET USER CB.HNDL, %PageNum, 1, %EN_CHANGE
                    END IF

                CASE %EN_KILLFOCUS : FUNCTION = 1
                    CONTROL GET USER CB.HNDL, %PageNum, 1 TO FR&
                    IF FR& = %EN_CHANGE THEN
                        CONTROL GET TEXT CB.HNDL, %PageNum TO Txt$
                        IF ( VAL( txt$ ) > 0 ) AND ( VAL( txt$ ) =< PC& ) THEN
                            PN& = VAL( txt$ )
                        END IF
                        CONTROL SET USER CB.HNDL, %PageNum, 1, %EN_KILLFOCUS

                    END IF

            END SELECT ' CB.CTLMSG

    END SELECT ' CB.CTL

    CONTROL GET USER CB.HNDL, %PageNum, 1 TO FR&

    IF FR& = %EN_KILLFOCUS THEN
        CONTROL SET USER CB.HNDL, %PageNum, 1, 0
        FR& = QuickPDFSelectPage( LibInstance&, PN& )
        CALL UpdateBuffer( CB.HNDL )
        CALL UpdateScreen( CB.HNDL )
    END IF

END IF

END FUNCTION ' OnEvent_Page

CALLBACK FUNCTION OnEvent_Print( ) AS LONG
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' contributed by Hans Rietveld
' page range selection add by Marc Giao
'
LOCAL Result    AS LONG ' function return result
LOCAL NF            AS LONG ' number of range fields
LOCAL SP            AS LONG ' start page number
LOCAL EP            AS LONG ' end page number
LOCAL X                 AS LONG ' index
LOCAL PR            AS STRING ' range of pages to print
LOCAL CP            AS STRING ' current printer
LOCAL Txt           AS STRING '

IF CB.MSG = %WM_COMMAND AND CB.CTLMSG = %BN_CLICKED THEN
    SELECT CASE CB.CTL
        CASE %PrintAll
            CONTROL SET TEXT CB.HNDL, %PageRange, "ALL"
        CASE %PrintOdd
            CONTROL SET TEXT CB.HNDL, %PageRange, "ODD"
        CASE %PrintEven
            CONTROL SET TEXT CB.HNDL, %PageRange, "EVEN"
        CASE %PrintSetup
        ' original code by Hans Rietveld, modified by Marc Giao
            XPRINT ATTACH CHOOSE
            CONTROL SET TEXT CB.HNDL, %Printer, XPRINT$

            IF TRIM$( XPRINT$ ) = "" THEN
                XPRINT ATTACH DEFAULT
                CONTROL SET TEXT CB.HNDL, %Printer, XPRINT$
            END IF
            XPRINT CLOSE

        CASE %PrintPDF
            CONTROL GET TEXT CB.HNDL, %PageRange TO PR$
            CONTROL GET TEXT CB.HNDL, %Printer TO CP$
                SELECT CASE PR$
                    CASE ""
                        EXIT FUNCTION

                    CASE "ALL"
                        SP& = 1
                        EP& = QuickPDFPageCount( LibInstance& )
                        XPRINT ATTACH CP$
                        STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 5, 0, "Printing:" + STR$(EP&) + " Pages"
                        Result& = QuickPDFPrintDocument( LibInstance&, XPRINT$ & $NUL, SP&, EP&, 0 )
                        XPRINT CLOSE

                    CASE "ODD"
                        SP& = 1
                        EP& = QuickPDFPageCount( LibInstance& )
                        XPRINT ATTACH CP$
                        FOR X = 1 TO EP& STEP 2
                            STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 5, 0, "Printing Page:" + STR$( X )
                            Result& = QuickPDFPrintDocument( LibInstance&, XPRINT$ & $NUL, X, X, 0 )
                        NEXT
                        XPRINT CLOSE

                    CASE "EVEN"
                        SP& = 2
                        EP& = QuickPDFPageCount( LibInstance& )
                        XPRINT ATTACH CP$
                        FOR X = 2 TO EP& STEP 2
                            STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 5, 0, "Printing Page:" + STR$( X )
                            Result& = QuickPDFPrintDocument( LibInstance&, XPRINT$ & $NUL, X, X, 0 )
                        NEXT
                        XPRINT CLOSE

                    CASE ELSE
                        PR$ = RETAIN$( PR$, ANY "-,1234567890" )
                        IF PR$ = "" THEN EXIT FUNCTION
                        NF& = PARSECOUNT( PR$, "," )
                        DIM PP( 1 TO NF& ) AS STRING ' array of pages to print
                        PARSE PR$, PP( )
                        XPRINT ATTACH CP$
                        FOR X = 1 TO NF&
                            IF PP( X ) = "" THEN ITERATE FOR
                            IF PARSECOUNT( PP( X ), "-" ) = 2 THEN
                                SP& = VAL( PARSE$( PP( X ), "-", 1 ) )
                                EP& = VAL( PARSE$( PP( X ), "-", 2 ) )
                                STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 5, 0, "Printing:" + STR$(SP&) + " to" + STR$(EP&)
                            ELSE
                                SP& = VAL( PP( X ) ) : EP& = SP&
                                STATUSBAR SET TEXT CB.HNDL, %ShowInfo, 5, 0, "Printing Page: " + STR$(SP&)
                            END IF
                            Result& = QuickPDFPrintDocument( LibInstance&, XPRINT$ & $NUL, SP&, EP&, 0 )

                        NEXT
                        XPRINT CLOSE

        END SELECT
    END SELECT

FUNCTION = 1

END IF

END FUNCTION ' OnEvent_Print

CALLBACK FUNCTION OnEvent_Scroll( ) AS LONG
LOCAL P AS LONG ' position of scrollbar
LOCAL L     AS LONG ' lo (min) limit of scroll range
LOCAL H     AS LONG     ' hi (max) limit of scroll range
LOCAL S AS LONG ' size of page
LOCAL D     AS LONG ' delta/step of line scroll
LOCAL T AS STRING ' text buffer

D& = 20

SELECT CASE AS LONG CB.MSG
    CASE %WM_HSCROLL ' horizontal scrollbar has been used
        SCROLLBAR GET PAGESIZE CB.HNDL, %HorSB TO S&
        SCROLLBAR GET RANGE CB.HNDL, %HorSB TO L&, H&

        SELECT CASE CB.CTL
'           CASE %SB_THUMBPOSITION
'           SCROLLBAR GET TRACKPOS CB.HNDL, %HorSB TO P&
'           SCROLLBAR SET POS CB.HNDL, %HorSB, P&

            CASE %SB_THUMBTRACK
            SCROLLBAR GET TRACKPOS CB.HNDL, %HorSB TO P&
            SCROLLBAR SET POS CB.HNDL, %HorSB, P&

            CASE %SB_LINERIGHT
            SCROLLBAR GET POS CB.HNDL, %HorSB TO P&
            P& += D& ': P& = MIN&( H&, P& ) 'stay in range
            SCROLLBAR SET POS CB.HNDL, %HorSB, P&

            CASE %SB_LINELEFT
            SCROLLBAR GET POS CB.HNDL, %HorSB TO P&
            P& -= D& ': P& = MAX&( L&, P& ) 'stay in range
            SCROLLBAR SET POS CB.HNDL, %HorSB, P&

            CASE %SB_PAGELEFT
            SCROLLBAR GET POS CB.HNDL, %HorSB TO P& ': P& -= S&
            P& -= S& ': P& = MAX&( L&, P& ) 'stay in range
            SCROLLBAR SET POS CB.HNDL, %HorSB, P&

            CASE %SB_PAGERIGHT
            SCROLLBAR GET POS CB.HNDL, %HorSB TO P&
            P& += S& ': P& = MIN&( H&, P& ) 'stay in range
            SCROLLBAR SET POS CB.HNDL, %HorSB, P&

            CASE %SB_LEFT
            SCROLLBAR SET POS CB.HNDL, %HorSB, L&

            CASE %SB_RIGHT
            SCROLLBAR SET POS CB.HNDL, %HorSB, H&

            CASE ELSE
                EXIT FUNCTION
        END SELECT
        FUNCTION = 1

    CASE %WM_VSCROLL ' vertical scrollbar has been used
        SCROLLBAR GET PAGESIZE CB.HNDL, %VerSB TO S&
        SCROLLBAR GET RANGE CB.HNDL, %VerSB TO L&, H&

        SELECT CASE CB.CTL
'           CASE %SB_THUMBPOSITION
'           SCROLLBAR GET TRACKPOS CB.HNDL, %VerSB TO P&
'           SCROLLBAR SET POS CB.HNDL, %VerSB, P&

            CASE %SB_THUMBTRACK
            SCROLLBAR GET TRACKPOS CB.HNDL, %VerSB TO P&
            SCROLLBAR SET POS CB.HNDL, %VerSB, P&

            CASE %SB_LINEDOWN
            SCROLLBAR GET POS CB.HNDL, %VerSB TO P&
            P& += D& ': P& = MIN&( H&, P& ) 'stay in range
            SCROLLBAR SET POS CB.HNDL, %VerSB, P&

            CASE %SB_LINEUP
            SCROLLBAR GET POS CB.HNDL, %VerSB TO P&
            P& -= D& ': P& = MAX&( L&, P& ) 'stay in range
            SCROLLBAR SET POS CB.HNDL, %VerSB, P&

            CASE %SB_PAGEDOWN
            SCROLLBAR GET POS CB.HNDL, %VerSB TO P&
            P& += S& ': P& = MIN&( H&, P& ) 'stay in range
            SCROLLBAR SET POS CB.HNDL, %VerSB, P&

            CASE %SB_PAGEUP
            SCROLLBAR GET POS CB.HNDL, %VerSB TO P&
            P& -= S& ': P& = MAX&( L&, P& ) 'stay in range
            SCROLLBAR SET POS CB.HNDL, %VerSB, P&

            CASE %SB_BOTTOM
            SCROLLBAR SET POS CB.HNDL, %VerSB, H&

            CASE %SB_TOP
            SCROLLBAR SET POS CB.HNDL, %VerSB, L&

            CASE ELSE
                EXIT FUNCTION
        END SELECT
        FUNCTION = 1

    CASE %WM_MOUSEWHEEL
    CASE %WM_NCACTIVATE
    CASE %WM_INITDIALOG
    CASE %WM_DESTROY
END SELECT

CALL UpdateScreen( CB.HNDL )

END FUNCTION ' OnEvent_Scroll

CALLBACK FUNCTION OnEvent_FullScreen( ) AS LONG
LOCAL S         AS LONG ' button state
LOCAL W         AS LONG ' width value
LOCAL H         AS LONG ' height value
LOCAL X         AS LONG ' x location
LOCAL Y         AS LONG ' y location

IF  CB.MSG = %WM_COMMAND AND    CB.CTL = %FullScreen AND CB.CTLMSG = %BN_CLICKED THEN
    CONTROL GET USER CB.HNDL, %FullScreen, 1 TO S&

    IF S& = %FullScreen THEN
        RESET S&
        CONTROL SET USER CB.HNDL, %FullScreen, 1, S&
        CONTROL SET TEXT CB.HNDL, %FullScreen, ">>"
' get the last position and size
        CONTROL GET USER CB.HNDL, %FullScreen, 2 TO W&
        CONTROL GET USER CB.HNDL, %FullScreen, 3 TO H&
        CONTROL GET USER CB.HNDL, %FullScreen, 4 TO X&
        CONTROL GET USER CB.HNDL, %FullScreen, 5 TO Y&
' hide the controls
        CALL UpdateControls( CB.HNDL, 0 )
' move and resize the dialog
        DIALOG SET LOC CB.HNDL, X&, Y&
        DIALOG SET SIZE CB.HNDL, W&, H&
' show the controls
        CALL UpdateControls( CB.HNDL, 1 )

        FUNCTION = 1

    ELSE
        S& = %FullScreen
        CONTROL SET USER CB.HNDL, %FullScreen, 1, S&
        CONTROL SET TEXT CB.HNDL, %FullScreen, "<<"
' get current dialog location and size
        DIALOG GET LOC CB.HNDL TO X&, Y&
        DIALOG GET SIZE CB.HNDL TO W&, H&
' save current dialog location and size
        CONTROL SET USER CB.HNDL, %FullScreen, 2, W&
        CONTROL SET USER CB.HNDL, %FullScreen, 3, H&
        CONTROL SET USER CB.HNDL, %FullScreen, 4, X&
        CONTROL SET USER CB.HNDL, %FullScreen, 5, Y&
' get desktop size
        DESKTOP GET CLIENT TO W&, H&
' hide the controls
        CALL UpdateControls( CB.HNDL, 0 )
' move and resize the dialog
        DIALOG SET LOC CB.HNDL, 0, 0
        DIALOG SET SIZE CB.HNDL, W&, H&
' show the controls
        CALL UpdateControls( CB.HNDL, 1 )

        FUNCTION = 1

    END IF

END IF

END FUNCTION ' OnEvent_FullScreen

FUNCTION UpdateControls( DlgHndl AS LONG, V AS LONG ) AS LONG
STATIC S    AS LONG ' visibility state of controls
LOCAL W     AS LONG ' width of dialog client area
LOCAL H         AS LONG ' height of dialog client area
LOCAL CH    AS LONG ' control height position

    DIALOG GET CLIENT DlgHndl& TO W&, H&

    V& = IIF&( V&, %SW_SHOW, %SW_HIDE )
    W& = IIF&( V&, MAX( %MinWinW, W& ), W& )
    H& = IIF&( V&, MAX( %MinWinH, H& ), H& )

IF V& = %SW_HIDE AND S& = 0 THEN
' delete the graphic control
    GRAPHIC DETACH
    CONTROL KILL DlgHndl&, %VDisplay

    S& = 1

END IF

' relocate file group
    CH& = 5
    CONTROL SET LOC DlgHndl&, %FileGroup, W& - 130, CH&
    CONTROL REDRAW DlgHndl&, %FileGroup
    CONTROL SET LOC DlgHndl&, %LoadFile, W& - 126, CH& + 15
    CONTROL REDRAW DlgHndl&, %LoadFile
    CONTROL SET LOC DlgHndl&, %LblCurrent, W& - 124, CH& + 47
    CONTROL REDRAW DlgHndl&, %LblCurrent
    CONTROL SET LOC DlgHndl&, %CurrentDoc, W& - 126, CH& + 60
    CONTROL REDRAW DlgHndl&, %CurrentDoc
    CONTROL SET LOC DlgHndl&, %CloseFile, W& - 126, CH& + 85
    CONTROL REDRAW DlgHndl&, %CloseFile
' relocate zoom group
    CH& = 135
    CONTROL SET LOC DlgHndl&, %ZoomGroup, W& - 130, CH&
    CONTROL REDRAW DlgHndl&, %ZoomGroup
    CONTROL SET LOC DlgHndl&, %ZoomVal, W& - 84, CH& + 21
    CONTROL REDRAW DlgHndl&, %ZoomVal
    CONTROL SET LOC DlgHndl&, %Zoom_O, W& - 126, CH& + 15
    CONTROL REDRAW DlgHndl&, %Zoom_O
    CONTROL SET LOC DlgHndl&, %Zoom_I, W& - 46, CH& + 15
    CONTROL REDRAW DlgHndl&, %Zoom_I
' relocate page group
    CH& = 195
    CONTROL SET LOC DlgHndl&, %PageGroup, W& - 130, CH&
    CONTROL REDRAW DlgHndl&, %PageGroup
    CONTROL SET LOC DlgHndl&, %PageNum, W& - 84, CH& + 21
    CONTROL REDRAW DlgHndl&, %PageNum
    CONTROL SET LOC DlgHndl&, %P_Page, W& - 126, CH& + 15
    CONTROL REDRAW DlgHndl&, %P_Page
    CONTROL SET LOC DlgHndl&, %N_Page, W& - 46, CH& + 15
    CONTROL REDRAW DlgHndl&, %N_Page
' relocate print group
    CH& = 255
    CONTROL SET LOC DlgHndl&, %PrintGroup, W& - 130, CH&
    CONTROL REDRAW DlgHndl&, %PrintGroup
    CONTROL SET LOC DlgHndl&, %PrintAll, W& - 126, CH& + 15
    CONTROL REDRAW DlgHndl&, %PrintAll
    CONTROL SET LOC DlgHndl&, %PrintOdd, W& - 92, CH& + 15
    CONTROL REDRAW DlgHndl&, %PrintOdd
    CONTROL SET LOC DlgHndl&, %PrintEven, W& - 50, CH& + 15
    CONTROL REDRAW DlgHndl&, %PrintEven
    CONTROL SET LOC DlgHndl&, %LblRange, W& - 125, CH& + 30
    CONTROL REDRAW DlgHndl&, %LblRange
    CONTROL SET LOC DlgHndl&, %PageRange, W& - 125, CH& + 45
    CONTROL REDRAW DlgHndl&, %PageRange
    CONTROL SET LOC DlgHndl&, %LblPrinter, W& - 125, CH& + 97
    CONTROL REDRAW DlgHndl&, %LblPrinter
    CONTROL SET LOC DlgHndl&, %Printer, W& - 125, CH& + 111
    CONTROL REDRAW DlgHndl&, %Printer

    CONTROL SET LOC DlgHndl&, %PrintPDF, W& - 126, CH& + 66
    CONTROL REDRAW DlgHndl&, %PrintPDF
    CONTROL SET LOC DlgHndl&, %PrintSetup, W& - 46, CH& + 66
    CONTROL REDRAW DlgHndl&, %PrintSetup
' relocate and resize horizontal scrollbar
    CONTROL SET LOC DlgHndl&, %HorSB, 4, H& - 45
    CONTROL SET SIZE DlgHndl&, %HorSB, W& - 158, 18
    CONTROL REDRAW DlgHndl&, %HorSB
' relocate and resize vertical scrollbar
    CONTROL SET LOC DlgHndl&, %VerSB, W& - 154, 4
    CONTROL SET SIZE DlgHndl&, %VerSB, 18, H& - 49
    CONTROL REDRAW DlgHndl&, %VerSB
' relocate full screen button
    CONTROL SET LOC DlgHndl&, %FullScreen, W& - 154, H& - 45
    CONTROL REDRAW DlgHndl&, %FullScreen

IF V& = %SW_SHOW THEN
' resize dialog client area
    DIALOG SET CLIENT DlgHndl&, W&, H&
' add new graphic control
    CONTROL ADD GRAPHIC, DlgHndl&, %VDisplay, "", 4, 4, W& - 158, H& - 49 _
        , %WS_CHILD OR %WS_VISIBLE OR %SS_OWNERDRAW OR %WS_BORDER _
        , %WS_EX_STATICEDGE ' CALL OnEvent_??()
    GRAPHIC ATTACH DlgHndl&, %VDisplay, REDRAW
    GRAPHIC CLEAR RGB( 70, 88, 118 ), 0

    DIALOG REDRAW DlgHndl&

    CALL UpdateScroll( DlgHndl& )
    CALL UpdateScreen( DlgHndl& )

    S& = 0
END IF


FUNCTION = 1

END FUNCTION ' ShowControls

FUNCTION UpdateScroll( DlgHndl AS LONG ) AS LONG
LOCAL FRC   AS LONG ' function return code
LOCAL BIW   AS LONG ' buffer image width
LOCAL BIH   AS LONG ' buffer image height
LOCAL DPI   AS LONG ' dpi (zoom)
LOCAL VAW   AS LONG ' view area width
LOCAL VAH   AS LONG ' view area height
LOCAL CSP   AS LONG ' current scrollbar position

FRC& = QuickPDFSetMeasurementUnits( LibInstance&, 2 )
CONTROL GET USER DlgHndl, %ZoomVal, 1 TO DPI&
CONTROL GET CLIENT DlgHndl, %VDisplay TO VAW&, VAH&

' account for page rotation
SELECT CASE QuickPDFPageRotation( LibInstance& )
    CASE 0 ' Portrait
    ' width/horizontal scrollbar
        BIW& = DPI& * ROUND( QuickPDFPageWidth( LibInstance& ), 2 )
    ' height/vertical scrollbar
        BIH& = DPI& * ROUND( QuickPDFPageHeight( LibInstance& ), 2 )

    CASE 90 ' Landscape
    ' width/horizontal scrollbar
        BIW& = DPI& * ROUND( QuickPDFPageHeight( LibInstance& ), 2 )
    ' height/vertical scrollbar
        BIH& = DPI& * ROUND( QuickPDFPageWidth( LibInstance& ), 2 )

    CASE 180 ' Flipped Portrait

    CASE 270 ' Flipped Landscape

END SELECT

    BIW& = MIN( %BMaxW, BIW& )
    BIH& = MIN( %BMaxH, BIH& )
' horizontal (width) scrollbar
    SCROLLBAR SET RANGE DlgHndl, %HorSB, 0, BIW&
    SCROLLBAR SET PAGESIZE DlgHndl, %HorSB, VAW& - 10
    SCROLLBAR GET POS DlgHndl, %HorSB TO CSP&
    SCROLLBAR SET POS DlgHndl, %HorSB, CSP&

' vertical (height) scrollbar
    SCROLLBAR SET RANGE DlgHndl, %VerSB, 0, BIH&
    SCROLLBAR SET PAGESIZE DlgHndl, %VerSB, VAH& - 10
    SCROLLBAR GET POS DlgHndl, %VerSB TO CSP&
    SCROLLBAR SET POS DlgHndl, %VerSB, CSP&

END FUNCTION ' UpdateScroll

FUNCTION UpdateBuffer( DlgHndl AS LONG ) AS LONG
LOCAL FRC   AS LONG ' function return code
LOCAL BDC   AS LONG ' buffer dc
LOCAL CPN   AS LONG     ' current page number
LOCAL DPI   AS LONG ' dpi (zoom)

    CONTROL GET USER DlgHndl, %ZoomVal, 1 TO DPI&
    GRAPHIC ATTACH BufferA&, 0
    GRAPHIC GET DC TO BDC&
    GRAPHIC CLEAR 0, 6

    CPN& = QuickPDFSelectedPage( LibInstance& )
    FRC& = QuickPDFRenderPageToDC( LibInstance&, DPI&, CPN&, BDC& )

END FUNCTION ' UpdateBuffer

FUNCTION UpdateScreen( DlgHndl AS LONG ) AS LONG
LOCAL FRV       AS LONG ' function return value
LOCAL DPI       AS LONG ' dpi (zoom)
LOCAL BW        AS LONG ' width of buffer
LOCAL BH        AS LONG     ' height of buffer
LOCAL VAW       AS LONG ' view area width
LOCAL VAH       AS LONG ' view area height
LOCAL VAC       AS LONG ' view area centre
LOCAL BDC       AS LONG
LOCAL SWP       AS LONG ' scrollbar width position
LOCAL SHP       AS LONG ' scrollbar height position
LOCAL SWR       AS LONG ' scrollbar width hi range
LOCAL SHR       AS LONG ' scrollbar height hi range
LOCAL CAW       AS LONG ' copy area width
LOCAL CAH       AS LONG ' copy area height
LOCAL BIW       AS LONG ' buffer image width
LOCAL BIH       AS LONG     ' buffer image height
LOCAL CPN       AS LONG ' current page number

    FRV& = QuickPDFSetMeasurementUnits( LibInstance& , 2 )
    CPN& = QuickPDFSelectedPage( LibInstance& )

    GRAPHIC ATTACH BufferA&, 0
    GRAPHIC GET CLIENT TO BW&, BH&
    CONTROL GET USER DlgHndl, %ZoomVal, 1 TO DPI&
    SCROLLBAR GET POS DlgHndl, %HorSB TO SWP&
    SCROLLBAR GET POS DlgHndl, %VerSB TO SHP&
    SCROLLBAR GET RANGE DlgHndl, %HorSB TO FRV&, SWR&
    SCROLLBAR GET RANGE DlgHndl, %VerSB TO FRV&, SHR&

    CONTROL GET CLIENT DlgHndl, %VDisplay TO VAW&, VAH&

' account for page rotation
    SELECT CASE QuickPDFPageRotation( LibInstance& )
        CASE 0 ' Portrait
            BIW& = DPI& * ROUND( QuickPDFPageWidth( LibInstance& ), 2 )
            BIH& = DPI& * ROUND( QuickPDFPageHeight( LibInstance& ), 2 )

        CASE 90 ' Landscape
            BIW& = DPI& * ROUND( QuickPDFPageHeight( LibInstance& ), 2 )
            BIH& = DPI& * ROUND( QuickPDFPageWidth( LibInstance& ), 2 )

        CASE 180 ' Flipped Portrait

        CASE 270 ' Flipped Landscape

    END SELECT

    SWP& -= 5 : SHP& -= 5
    BIW& = MIN( %BMaxW, BIW& - 1 )
    BIH& = MIN( %BMaxH, BIH& - 1 )
    CAW& = MIN( BIW&, SWP& + VAW& )
    CAH& = MIN( BIH&, SHP& + VAH& )
    VAC& = MAX( 0, ( VAW& - BIW& ) \ 2 )


    GRAPHIC ATTACH DlgHndl, %VDisplay, REDRAW
    GRAPHIC GET DC TO BDC&
    GRAPHIC CLEAR  RGB( 70, 88, 118 ), 0 'RGB( 103, 103, 103 )
    GRAPHIC COPY BufferA&, 0, ( SWP&, SHP& )-( CAW&, CAH& ) TO ( VAC&, 0 )
    GRAPHIC REDRAW

    CONTROL SET TEXT DlgHndl&, %PageNum, TRIM$( STR$( CPN& ) )
    CONTROL SET TEXT DlgHndl&, %ZoomVal, TRIM$( STR$( DPI& ) )
    CONTROL SET TEXT DlgHndl&, %PageRange, TRIM$( STR$( CPN& ) ) + "-" + TRIM$( STR$( CPN& ) )

    FUNCTION = 1

END FUNCTION ' UpdateScreen

FUNCTION UpdateDocInfo( ) AS LONG
LOCAL Txt AS STRING

    Txt$ = "PDF Ver: " + QuickPDFGetInformation( LibInstance&, 0 )
    STATUSBAR SET TEXT MainHndl, %ShowInfo, 1, 0, Txt$

    Txt$ = "Page Count: " + STR$( QuickPDFPageCount( LibInstance& ) )
    STATUSBAR SET TEXT MainHndl, %ShowInfo, 2, 0, Txt$

    Txt$ = "Page Size:" + STR$( ROUND( QuickPDFPageWidth( LibInstance& ), 2 ) )
    Txt$ += " x" + STR$( ROUND( QuickPDFPageHeight( LibInstance& ), 2 ) )
    STATUSBAR SET TEXT MainHndl, %ShowInfo, 3, 0, Txt$

    SELECT CASE QuickPDFPageRotation( LibInstance& )
        CASE 0
            Txt$ = "Portrait"
        CASE 90
            Txt$ = "Landscape"
        CASE 180
            Txt$ = "Flipped Portrait"
        CASE 270
            Txt$ = "Flipped Landscape"
    END SELECT

    STATUSBAR SET TEXT MainHndl, %ShowInfo, 4, 0, "Orientation: " + Txt$

'   Info$ += "  Author = " + QuickPDFGetInformation( LibInstance&, 1 ) + $CRLF
'   QuickPDFGetInformation( LibInstance&, 5 )
'   txt$ += "  Creator = " + STR$( QuickPDFStringResultLength( LibInstance& ) ) + $CRLF
'   txt$ += "  Creator = " + QuickPDFGetInformation( LibInstance&, 5 ) + $CRLF
'   txt$ += "  Producer = " + QuickPDFGetInformation( LibInstance&, 6 ) + $CRLF
'   txt$ += $CRLF + "Printer:" + $CRLF ' supplied by Hans Rietveld
'   txt$ += "  " + PrintSel + $CRLF ' supplied by Hans Rietveld

    FUNCTION = 1

END FUNCTION ' UpdateDocInfo

FUNCTION BuiltWith( DlgHndl AS LONG ) AS LONG
LOCAL BWH AS DWORD
LOCAL W         AS LONG
LOCAL H         AS LONG

' load resource
    GRAPHIC BITMAP LOAD "BUILTWITH", 0, 0 TO BWH???
' centre and display
    GRAPHIC ATTACH DlgHndl, %VDisplay, REDRAW
    GRAPHIC CLEAR  RGB( 70, 88, 118 ), 0
    GRAPHIC GET CLIENT TO W&, H&
    W& = ( W& - 600 ) \ 2
    H& = ( H& - 160 ) \ 2
    GRAPHIC COPY BWH???, 0 TO ( W&, H& )
    GRAPHIC REDRAW
' release the control
    GRAPHIC ATTACH BWH???, 0
    GRAPHIC BITMAP END

END FUNCTION ' BuiltWith
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' end of active code, test code may follow
'
